Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## sim.util
Class Properties

    java.lang.Object
      sim.util.Properties

All Implemented Interfaces:
  java.io.Serializable

Direct Known Subclasses:
  CollectionProperties, SimpleProperties

    public abstract class Properties

extends java.lang.Object
implements java.io.Serializable

The abstract superclass of Property inspectors. Such a beast inspects an object and returns a list of variables for which there are get and possibly set methods.

There are two such inspectors: SimpleProperties (inspects objects for their slots) and CollectionProperties (inspects Collections, Maps, and arrays for their contents). The easiest way to get an appropriate Properties subclass instance is to simply call the static method Properties.getProperties(object to inspect, .... ). See the SimpleProperties and CollectionProperties classes for specifics about how they define what a Property is. SimpleProperties in particular will beinteresting..

Property inspectors enumerate the Properties in their provided object. SimpleProperties will enumerate each of the slots; and CollectionProperties will enumerate the elements in the corresponding array, Map, Collection, etc. You get the number of Properties with numProperties(). Properties have the following features:

- Property Name (Readable). A string, usually the name of the instance variable in the object, a stringified number ("1", "203", etc.) for Collections or Arrays, or a stringified version of the key in a Map.
- Property Value (Readable and possibly Writable). An object representing the value of the property. Numbers etc. are wrapped in their corresponding wrapper classes.
- Writability (Readable).
- Type (Readable). The type of the object as a Class. ints return Integer.TYPE, etc.
- Composite Nature (Readable). Whether or not the Property is composite or atomic. Atomic types are int, float, etc., plus String.
- Domain (Readable). Whether or not the object has defined a Domain (a set or range of legal values) for the Property. Domains allow a GUI to set up sliders, pull-down menus and combo-boxes, etc.
- Description (Readable). A string describing an extended description of the property. Returns null (the default) if there is no extended description.
- Hiddenness (Readable). A boolean indicating whether the property should be shown to the user.

See Also:
  Serialized Form

Field Summary
`protected java.lang.Object` | `object`

Constructor Summary
`Properties()`

Method Summary
`protected abstract java.lang.Object` | `_setValue(int index, java.lang.Object value)`
`java.lang.String` | `betterToString(java.lang.Object obj)` Call this to get a prettier print-name for an object -- converting arrays to a nicer format, for example.
`java.lang.String` | `getDescription(int index)` Returns the description of the property at the given index.
`java.lang.Object` | `getDomain(int index)` Returns the domain of the property at the given index.
`abstract java.lang.String` | `getName(int index)` Returns the name of the property at the given index.
`java.lang.Object` | `getObject()` Returns the original object from which the properties are extracted
`static Properties` | `getProperties(java.lang.Object object)` Returns a Properties object for the given object.
`static Properties` | `getProperties(java.lang.Object object, boolean expandCollections, boolean includeSuperclasses, boolean includeGetClass)` Deprecated. use the full version
`static Properties` | `getProperties(java.lang.Object object, boolean expandCollections, boolean includeSuperclasses, boolean includeGetClass, boolean includeExtensions)` Returns a Properties object for the given object.
`abstract java.lang.Class` | `getType(int index)` Returns the Class (or for primitive objects, the primitive TYPE) of the property at the given index.
`protected java.lang.Class` | `getTypeConversion(java.lang.Class type)`
`abstract java.lang.Object` | `getValue(int index)` Returns the value of the property at the given index.
`boolean` | `isComposite(int index)` Returns true if the property at the given index is a "Composite" object, meaning it's not a primitive type (double, int, etc.) nor a String.
`boolean` | `isHidden(int index)` Returns true if the class requested that this property be hidden from the user.
`abstract boolean` | `isReadWrite(int index)` Returns true if the property at the given index is both readable and writable (as opposed to read-only).
`abstract boolean` | `isVolatile()` Returns true if the number or order of properties could change at any time
`abstract int` | `numProperties()` Returns the number of properties discovered in the object.
`java.lang.Object` | `setValue(int index, java.lang.Object value)` Sets the current value of the property.
`java.lang.Object` | `setValue(int index, java.lang.String value)` Sets the current value of the property to the value parsed from the given string.
`protected java.lang.String` | `typeToName(java.lang.Class type)`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### object

    protected java.lang.Object object

Constructor Detail

### Properties

    public Properties()

Method Detail

### getProperties

    public static Properties getProperties(java.lang.Object object)

  Returns a Properties object for the given object. If the object is an array, Map, Indexed, or Collection, then it will be treated using CollectionProperties. Otherwise it will be treated using SimpleProperties. The returned SimpleProperties will include superclasses properties. The Class property will NOT be included. The domFoo() and hideFoo() property extension methods are respected. Domains will always be produced according to the rules in the comments for getDomain(index) below.

### getProperties

    public static Properties getProperties(java.lang.Object object,
                                           boolean expandCollections,
                                           boolean includeSuperclasses,
                                           boolean includeGetClass)

  Deprecated. use the full version

  Returns a Properties object for the given object. If expandCollections is true, then if object is a Map, Indexed, or Collection, then it will be treated using CollectionProperties. Otherwise it will be treated using SimpleProperties. Arrays are always treated using CollectionProperties. If includeSuperclasses is true, then any SimpleProperties will include superclasses. If includeGetClass is true, then the Class property will be included. The domFoo() and hideFoo() property extension methods are respected.

### getProperties

    public static Properties getProperties(java.lang.Object object,
                                           boolean expandCollections,
                                           boolean includeSuperclasses,
                                           boolean includeGetClass,
                                           boolean includeExtensions)

  Returns a Properties object for the given object. If expandCollections is true, then if object is a Map, Indexed, or Collection, then it will be treated using CollectionProperties. Otherwise it will be treated using SimpleProperties. Arrays are always treated using CollectionProperties. If includeSuperclasses is true, then any SimpleProperties will include superclasses. If includeGetClass is true, then the Class property will be included. The domFoo() and hideFoo() property extension methods are respected if `includeExtensions` is true.

### getObject

    public java.lang.Object getObject()

  Returns the original object from which the properties are extracted

### isVolatile

    public abstract boolean isVolatile()

  Returns true if the number or order of properties could change at any time

### numProperties

    public abstract int numProperties()

  Returns the number of properties discovered in the object.

### getValue

    public abstract java.lang.Object getValue(int index)

  Returns the value of the property at the given index.

### getDomain

    public java.lang.Object getDomain(int index)

  Returns the domain of the property at the given index. Domains are defined by methods of the form `public Object domProperty()` and should generally take one of three forms:
  `null`
    no domain (domain is infinite).
  An array of elements
    the domain consists solely of those elements.
  A `sim.util.Interval`
    the domain is an inclusive (closed) numerical range defined by the Interval. If the Interval returns Longs, then the domain is considered to be integral; else it is considered to be real-valued.

### getDescription

    public java.lang.String getDescription(int index)

  Returns the description of the property at the given index. Descriptions are defined by methods of the form `desProperty()` and are either `null` (no description), or are Strings, possibly including HTML data. The primary function of description methods is to provide tooltip information for widgets describing the Property.

### isReadWrite

    public abstract boolean isReadWrite(int index)

  Returns true if the property at the given index is both readable and writable (as opposed to read-only).

### isComposite

    public boolean isComposite(int index)

  Returns true if the property at the given index is a "Composite" object, meaning it's not a primitive type (double, int, etc.) nor a String.

### isHidden

    public boolean isHidden(int index)

  Returns true if the class requested that this property be hidden from the user. By default, false.

### getName

    public abstract java.lang.String getName(int index)

  Returns the name of the property at the given index.

### getType

    public abstract java.lang.Class getType(int index)

  Returns the Class (or for primitive objects, the primitive TYPE) of the property at the given index.

### _setValue

    protected abstract java.lang.Object _setValue(int index,
                                                  java.lang.Object value)

### setValue

    public java.lang.Object setValue(int index,
                                     java.lang.Object value)

  Sets the current value of the property. Simple values (byte, int, etc.) must be boxed (into Byte, Integer, etc.). Then returns the current (hopefully changed) value of the property. Returns null if an error occurs or if the index is out of the range [0 ... numProperties() - 1 ]

### setValue

    public java.lang.Object setValue(int index,
                                     java.lang.String value)

  Sets the current value of the property to the value parsed from the given string. Then returns the current (hopefully changed) value of the property. Returns null if an error occurs or if the index is out of the range [0 ... numProperties() - 1 ]

### getTypeConversion

    protected java.lang.Class getTypeConversion(java.lang.Class type)

### betterToString

    public java.lang.String betterToString(java.lang.Object obj)

  Call this to get a prettier print-name for an object -- converting arrays to a nicer format, for example.

### typeToName

    protected java.lang.String typeToName(java.lang.Class type)

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD